<template>
  <v-form>
    <v-container fluid>
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.name"
            :error-messages="nameErrors"
            :label="$t('name')"
            @input="$v.item.name.$touch()"
            @blur="$v.item.name.$touch()"
          />
        </v-col>
      
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.logo"
            :error-messages="logoErrors"
            :label="$t('logo')"
            @input="$v.item.logo.$touch()"
            @blur="$v.item.logo.$touch()"
          />
        </v-col>
      </v-row>
      
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.street"
            :error-messages="streetErrors"
            :label="$t('street')"
            @input="$v.item.street.$touch()"
            @blur="$v.item.street.$touch()"
          />
        </v-col>
      
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.city"
            :error-messages="cityErrors"
            :label="$t('city')"
            @input="$v.item.city.$touch()"
            @blur="$v.item.city.$touch()"
          />
        </v-col>
      </v-row>
      
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.country"
            :error-messages="countryErrors"
            :label="$t('country')"
            @input="$v.item.country.$touch()"
            @blur="$v.item.country.$touch()"
          />
        </v-col>
      
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.zc"
            :error-messages="zcErrors"
            :label="$t('zc')"
            @input="$v.item.zc.$touch()"
            @blur="$v.item.zc.$touch()"
          />
        </v-col>
      </v-row>
      
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.siret"
            :error-messages="siretErrors"
            :label="$t('siret')"
            @input="$v.item.siret.$touch()"
            @blur="$v.item.siret.$touch()"
          />
        </v-col>
      
        <v-col cols="12" sm="6" md="6">
          <v-combobox
            v-model="item.store"
            :items="storeSelectItems"
            :error-messages="storeErrors"
            :no-data-text="$t('No results')"
            :label="$t('store')"
            item-text="name"
            item-value="@id"
          />
        </v-col>
      </v-row>
      
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-combobox
            v-model="item.renters"
            :items="rentersSelectItems"
            :error-messages="rentersErrors"
            :no-data-text="$t('No results')"
            :label="$t('renters')"
            multiple
            item-text="name"
            item-value="@id"
            chips
          />
        </v-col>
      
        <v-col cols="12"></v-col>
      </v-row>
      
    </v-container>
  </v-form>
</template>

<script>
import has from 'lodash/has';
import { validationMixin } from 'vuelidate';
//import { required } from 'vuelidate/lib/validators';
import { mapActions } from 'vuex';
import { mapFields } from 'vuex-map-fields';

export default {
  name: 'CompanyForm',
  mixins: [validationMixin],
  props: {
    values: {
      type: Object,
      required: true
    },

    errors: {
      type: Object,
      default: () => {}
    },

    initialValues: {
      type: Object,
      default: () => {}
    }
  },
  mounted() {
      this.storeGetSelectItems();
      this.rentersGetSelectItems();
  },
  data() {
    return {
        name: null,
        logo: null,
        street: null,
        city: null,
        country: null,
        zc: null,
        siret: null,
        store: null,
        renters: null,
    };
  },
  computed: {
      ...mapFields('store', {
        storeSelectItems: 'selectItems'
      }),
      ...mapFields('user', {
        rentersSelectItems: 'selectItems'
      }),

    // eslint-disable-next-line
    item() {
      return this.initialValues || this.values;
    },

    nameErrors() {
      const errors = [];

      if (!this.$v.item.name.$dirty) return errors;

      has(this.violations, 'name') && errors.push(this.violations.name);


      return errors;
    },
    logoErrors() {
      const errors = [];

      if (!this.$v.item.logo.$dirty) return errors;

      has(this.violations, 'logo') && errors.push(this.violations.logo);


      return errors;
    },
    streetErrors() {
      const errors = [];

      if (!this.$v.item.street.$dirty) return errors;

      has(this.violations, 'street') && errors.push(this.violations.street);


      return errors;
    },
    cityErrors() {
      const errors = [];

      if (!this.$v.item.city.$dirty) return errors;

      has(this.violations, 'city') && errors.push(this.violations.city);


      return errors;
    },
    countryErrors() {
      const errors = [];

      if (!this.$v.item.country.$dirty) return errors;

      has(this.violations, 'country') && errors.push(this.violations.country);


      return errors;
    },
    zcErrors() {
      const errors = [];

      if (!this.$v.item.zc.$dirty) return errors;

      has(this.violations, 'zc') && errors.push(this.violations.zc);


      return errors;
    },
    siretErrors() {
      const errors = [];

      if (!this.$v.item.siret.$dirty) return errors;

      has(this.violations, 'siret') && errors.push(this.violations.siret);


      return errors;
    },
    storeErrors() {
      const errors = [];

      if (!this.$v.item.store.$dirty) return errors;

      has(this.violations, 'store') && errors.push(this.violations.store);


      return errors;
    },
    rentersErrors() {
      const errors = [];

      if (!this.$v.item.renters.$dirty) return errors;

      has(this.violations, 'renters') && errors.push(this.violations.renters);


      return errors;
    },

    violations() {
      return this.errors || {};
    }
  },
  methods: {
      ...mapActions({
        storeGetSelectItems: 'store/fetchSelectItems'
      }),
      ...mapActions({
        rentersGetSelectItems: 'user/fetchSelectItems'
      }),
  },
  validations: {
    item: {
      name: {
      },
      logo: {
      },
      street: {
      },
      city: {
      },
      country: {
      },
      zc: {
      },
      siret: {
      },
      store: {
      },
      renters: {
      },
    }
  }
};
</script>
